Subject: Re: bug#57434: 28.1.91; Terminal Emacs Mac OS flickering.

From: Dmitrii Kuragin <[email-masked]>
Date: Mon, 29 Aug 2022 12:26:07 -0700

I tried different terminal emulators, Alacritty, iTerm2, Terminal.app
(stock). All of them show the same issue. So, it is not a terminal emulator.

Additional info:

When the screen flickers I alway see only 2 rectangles w/o content and they
always are the same for the same scroll position.

Looking into the debugger, it corresponds to the same number of insertions
and insert positions. The more heavy content on the screen the more
frequently the regions w/o get visible.

As an option, we can add the optional flag where we can entirely disable
the optimization and probably let people test it on their setups.

One more possible cause is 24 bit colors in my terminal:
https://github.com/syl20bnr/spacemacs/wiki/Terminal

But, even when I run emacs using 256 colors:
```
echo $TERM
xterm-256color
```

But, It still shows the same issue.

I am open to any possible solution. What would you like me to do? :)

On Mon, Aug 29, 2022 at 12:16 PM Eli Zaretskii <[email-masked]> wrote:

> > From: Dmitrii Kuragin <[email-masked]>
> > Date: Mon, 29 Aug 2022 12:04:38 -0700
> > Cc: Gerd Möllmann <[email-masked]>,
> >       [email-masked]
> >
> >  More generally, we need to understand why insertion cause flickering
> >  whereas writing to the terminal does not.
> >
> > I agree.
> >
> > Let's ignore what I said about flushing. My assumption was that we draw
> the terminal content in multiple steps
> > in different places. For example, we remove some lines, then do some
> logic, then we draw chars on top of it.
> > So, if we have a lag between the operations and the terminal refreshes
> the screen we see only part of the
> > content. But, as I said. Let's ignore that and if you have any guidance
> on how I can debug it further, it would be
> > awesome.
> >
> > Flickering is consistent for some specific area. If I scroll between 2
> lines, back-and-forth Emacs flickers
> > consistently.
> >
> > What would be my next steps to give more debug information?
>
> Can you try some other terminal emulator?  I'm interested to know
> whether all of them flicker, or just some.
>
> Another idea is to disable the insert/delete optimization entirely, by
> making sure the line_ins_del_ok flag of the terminal is reset.  The
> question, of course, is what to base this on -- could be macOS or just
> some specific terminal type.
>

-- 
*If you get an email from me outside of the 9-5 it is *not* because I'm
always on or expect an immediate response from you; it is because of work
flexibility
<http://www.inc.com/john-boitnott/how-flexible-hours-can-create-a-better-work-life-balance.html>
.  Evening and weekend emails are a sign I allocated some regular working
hours for other things (such as family, gym, friends,...).  And I encourage
you to feel free to do the same.